<?php 
require_once("config.php");
require_once("functions.inc.php");
require_once("system.php");
require_once("xml2array.php");
require_once("dblib.php");
require_once("asmanager.php");
require_once("dbconn.php");

$action = isset($_REQUEST['action'])?$_REQUEST['action']:'';
$itemid = isset($_REQUEST['itemid'])?$_REQUEST['itemid']:'';

$upload_msg = '';


$fop2_mirror = getFastestMirror();

if($action=='getplugin') {

    plugin_download($itemid, $fop2_mirror);

    exit;

} else if($action=='upload') {

    $res = plugin_handleupload($_FILES['uploadplug']);

    if (is_array($res)) {
        $upload_msg = "<div class='alert alert-danger'>\n";
        $upload_msg.= "<p>";
        $upload_msg.= sprintf(__('The following error(s) occurred processing the uploaded file: %s'), '<ul><li>'.implode('</li><li>',$res).'</li></ul>');
        $upload_msg.= "</p></div>\n";
    } else {
        $upload_msg = "<div class='alert alert-success'>";
        $upload_msg.= "<p>".__("Plugin uploaded successfully. You need to enable it globally or assign it to fop2 users to make it available.")."</p>\n";
        $upload_msg.= "</div>\n";
    }

} else if($action=='delplugin') {

    plugin_delete($itemid);

} else if ($action=='setglobal') {

    $rawname = $_REQUEST['fop2plugin'];
    $enabled = $_REQUEST['fop2globalenabled'];
    $db->consulta("UPDATE fop2plugins SET global='".$db->escape_string($enabled)."' WHERE rawname='".$db->escape_string($rawname)."'");
    exit;

} else if ($action=='savePluginConfig') {

    $directory = dirname(__FILE__)."/plugins/";
    $rawname = $_REQUEST['plugin'];
    $inifile = $directory."$rawname/$rawname.ini";
    $ini_array = array();
    foreach($_REQUEST as $key=>$val) {
        if(preg_match("/$rawname/",$key)) {
            list ($plug, $field, $section) = preg_split("/-/",$key);
            if($section=='default') {
                $ini_array[$field]=$val;
            } else if($section=='skeleton') {
            } else {
                $ini_array[$section][$field]=$val;
            } 
        }
    }

    $res = array();
    foreach($ini_array as $key => $val)
    {
        if(is_array($val))
        {
            $res[] = "[$key]";
            foreach($val as $skey => $sval) $res[] = "$skey = ".(is_numeric($sval) ? $sval : '"'.$sval.'"');
        }
        else $res[] = "$key = ".(is_numeric($val) ? $val : '"'.$val.'"');
    }
    file_put_contents($inifile, implode("\r\n", $res), LOCK_EX);

    reload_asterisk();
}

$plugin_online = plugin_get_online($fop2_mirror);
$plugin_local  = get_installed_plugins('version');
$plugin_global = plugin_get_global();

if (isset($plugin_online)) {
	foreach ($plugin_online as $idx=>$arrdata) {
        $plugin_sorted[$idx]=$arrdata['name'];
    }
}
asort($plugin_sorted);

include("headerbs.php");
include("menu.php");

?>
<div class="content">
<?php
$licensedplugins=explode(',',plugin_get_licensed());

if($licensedplugins[0] == '0') {

    echo  "<div class='alert alert-danger alert-dismissable'>";
    echo "<button type='button' class='close' data-dismiss='alert' aria-hidden='true'>&times;</button>\n";
    echo __("FOP2 Server is not responding. Be sure the service is running!");
    echo "</div>\n";

}

if($upload_msg <> '') { echo $upload_msg; }
?>
<div id="modulelist">
  <div class="category" id="category_Online">
  <h3><?php echo __("FOP2 Repository - Available Plugins") ?></h3>
  <hr style='color: #bbb; background-color: #bbb; height: 2px;'/>
<?php
    echo "<table style='border-collapse:collapse; width:100%;' class='table fop2plugin'>"; 
    echo "<thead><tr><th>".__('Name')."</th><th>".__('Installed Version')."</th><th>".__('Available Version')."</th><th>".__('Globally Enabled')."</th><th></th></tr></thead>";
    echo "<tbody>";
if (isset($plugin_online)) {

	foreach ($plugin_sorted as $idx=>$plugname) {
        $arrdata = $plugin_online[$idx];

        $rawname           = $arrdata['rawname'];
        $name              = $arrdata['name'];
        $version           = $arrdata['version'];
        $description       = $arrdata['description'];
        $price             = intval($arrdata['price']);
        $engine            = ($arrdata['engine']<>'')?$arrdata['engine']:$config_engine;
        $global            = ($arrdata['global']<>'')?$arrdata['global']:'no';
        $installed_version = '-';

        if(isset($arrdata['description-'.strtolower($_COOKIE['lang'])])) {
            $description = $arrdata['description-'.strtolower($_COOKIE['lang'])];
            $description = str_replace(array("\0", "\n", "\t", "\r"), '', $description);
        }

        $partes = preg_split('/\./',$version);
        $superversion = $partes[0]*100000 + $partes[1]*1000 + $partes[2]*10;

        // skip plugins for other engines
        if($config_engine <> $engine) { continue; }

        if(isset($plugin_local[$rawname])) {
            $installed_version = $plugin_local[$rawname];
            $partes = preg_split('/\./',$plugin_local[$rawname]);
            $superversionlocal = $partes[0]*100000 + $partes[1]*1000 + $partes[2]*10;
        } else {
            $superversionlocal = 0;
        }

        if(in_array($rawname,$licensedplugins)) { $paid=1; } else { $paid=0; }

        if($superversion == $superversionlocal) { 
            $delurl = SELF;
            $status = "<form method=post action='$delurl' id='delete_".$rawname."'>\n";
            $status.= "<input type=hidden name=action value='delplugin'>\n";
            $status.= "<input type=hidden name='itemid' value='$rawname'>\n";
            $status.= "<button class='btn btn-danger col-md-12' onclick='setUninstall(\"$rawname\"); return false;'>".__('Uninstall')."</button>\n";
            $status.= "</form>\n";
        } else if($superversionlocal==0) {
            if($price==0 || ($price>0 && $paid==1)) {
                $geturl = SELF;
                $status = "<form method=post action='$geturl'>\n";
                $status.= "<input type=hidden name='itemid' value='$rawname-$version'>\n";
                $status.= "<input type=hidden name='action' value='getplugin'>\n";
                $status.= "<button class='btn btn-success col-md-12' onclick='getPlugin(\"$rawname-$version\"); return false;'>".__('Install')."</button>\n";
                $status.= "</form>";
            } else {
                $geturl = 'http://www.fop2.com/buy.php';
                $status = "<a class='btn btn-warning col-md-12' href='$geturl'>".__('Buy')."</a>";
            }
        } else if($superversionlocal<$superversion) {
            $geturl = SELF;
            $status = "<form method=post action='$geturl'>\n";
            $status.= "<input type=hidden name=action value='getplugin'>\n";
            $status.= "<input type=hidden name=itemid value='$rawname-$version'>\n";
            $status.= "<button class='btn btn-primary col-md-12' href='$geturl' onclick='getPlugin(\"$rawname-$version\"); return false;'>";
            $status.= __('Update');
            $status.= "</button></form>";
        }
        
        if(isset($plugin_global[$rawname]) || $global=='yes') { $checked=' checked '; } else { $checked=''; }
        if($global=='yes') { $disabled='disabled=disabled'; } else { $disabled=''; }
        if($price<=0) { $pr="<span class='label label-success'>".__('Free')."</span>";} else { if($paid==1) { $pr="<span class='label label-default' style='text-decoration:line-through;'>$".number_format($price,2)."</span>"; } else {$pr="<span class='label label-info'>$".number_format($price,2)."</span>"; }}
        echo "<tr>\n";
        echo "<td>$pr <strong>$name</strong></td>";
        echo "<td>$installed_version</td>";
        echo "<td>$version</td>";
        echo "<td><input id='global_".$rawname."' type='checkbox' $checked $disabled onclick='setGlobalPlugin(this);'/></td>";
        echo "<td style='text-align:right;'>$status</td>"; 
        echo "</tr>";
        if($superversionlocal>0) {
            $configparams = plugin_read_xml_params($rawname);
            if(count($configparams)>0) {

                echo "<tr>\n";
                echo "<td colspan=4>$description</td>";
                echo "<td style='text-align:right;'>";
                echo "<button type='button' class='btn btn-default ttip' ";
                echo "data-toggle='popover' data-trigger='hover' data-placement='bottom' data-content='";
                echo __('Hide/Show Plugin Settings'); 
                echo "' onclick='toggleconfig(\"".$rawname."\")'>";
                echo "<span class='glyphicon glyphicon-cog'>";
                echo "</span></button>";
                echo "</td>";
                echo "</tr>";

                echo "<tr><td colspan=5><div id='config_$rawname' style='display:none;'><hr/>";
                echo fop2_print_config_form($rawname);
                echo "</div></td></tr>";
            } else {
                echo "<tr><td colspan=5>$description</td>";
                echo "</tr>";
            }
        } else {
            echo "<tr><td colspan=5>$description</td>";
            echo "</tr>";
        }

        echo "<tr><td colspan=5 class='fop2pluginseparator'>&nbsp;</td></tr>";
    }
} else {
    echo "<tr><td colspan=5><span style='color:red; font-weight:bold;'>".__('Online Repository not reachable/accessible')."</span></td></tr>";
}
echo "</tbody></table>\n";
echo "</div></div>\n";

echo "<hr style='color: #bbb; background-color: #bbb; height: 2px;'/>\n";
$plugname_online=array();
foreach ($plugin_online as $idx=>$arrdata) {
    $plugname_online[$arrdata['rawname']]=$arrdata['version'];
}
$locally_installed_not_online = array_diff_assoc($plugin_local, $plugname_online);

echo "<div id='modulelistlocal'>
  <div class='category' id='category_Local'>
  <h3> ".__("Locally Available Plugins")."</h3>";

if(count($locally_installed_not_online>0)) {

    echo "<table style='border-collapse:collapse; width:100%;' class='table fop2plugin'>"; 
    echo "<thead><tr><th>".__('Name')."</th><th>".__('Installed Version')."</th><th>".__('Globally Enabled')."</th><th></th></tr></thead>";
    echo "<tbody>";

	foreach ($locally_installed_not_online as $rawname=>$version) {

        $directory = dirname(__FILE__)."/plugins/";
        $infoxml   = substr(escapeshellarg($directory."$rawname/plugin.xml"),1,-1);

        if(is_readable($infoxml)) {
            $pluginxml = file_get_contents($infoxml);
            $xml       = new xml2Array();
            $xmlarray  = $xml->parseAdvanced($pluginxml);
            $data      = $xmlarray['plugin'];
            if(!isset($data['global'])) { $data['global']=''; }
            $global    = ($data['global']<>'')?$data['global']:'no';
        } else {
            $data['rawname']     = $rawname;
            $data['name']        = $rawname;
            $data['version']     = $version;
            $data['description'] = '';
        }
        $rawnamedb     = $db->escape_string($data['rawname']);
        $namedb        = $db->escape_string($data['name']);
        $versiondb     = $db->escape_string($data['version']);
        $descriptiondb = $db->escape_string($data['description']);

        $description   = $data['description'];
        if(isset($data['description-'.strtolower($_COOKIE['lang'])])) {
            $description = $data['description-'.strtolower($_COOKIE['lang'])];
            $description = str_replace(array("\0", "\n", "\t", "\r"), '', $description);
        }

        if(isset($plugin_global[$data['rawname']]) || $global=='yes') { $checked=' checked '; } else { $checked=''; }
        if($global=='yes') { $disabled='disabled=disabled'; } else { $disabled=''; }

        $results = $db->consulta( "INSERT INTO fop2plugins (rawname, name, version, description) values ('".$rawnamedb."','".$namedb."','".$versiondb."','".$descriptiondb."') ON DUPLICATE KEY UPDATE rawname='$rawnamedb', name='$namedb', version='$versiondb', description='$descriptiondb'");

        echo "<tr>\n";
        echo "<td><strong>".$data['name']."</strong></td>";
        echo "<td>".$data['version']."</td>";
        echo "<td><input id='global_".$rawname."' type='checkbox' $checked $disabled onclick='setGlobalPlugin(this);'/></td>";

        echo "<td style='text-align:right;'>";
        echo "<button type='button' class='btn btn-default ttip' ";
        echo "data-toggle='popover' data-trigger='hover' data-placement='bottom' data-content='";
        echo __('Hide/Show Plugin Settings'); 
        echo "' onclick='toggleconfig(\"".$rawname."\")'>";
        echo "<span class='glyphicon glyphicon-cog'>";
        echo "</span></button>";
        echo "</td>";
 
        echo "</tr>";
        echo "<tr><td colspan=4>".$description."</td></tr>";
        //if($superversionlocal>0) {
            $configparams = plugin_read_xml_params($rawname);
            if(count($configparams)>0) {
                echo "<tr><td colspan=4><div id='config_$rawname' style='display:none;'><hr/>\n";
                echo fop2_print_config_form($rawname);
                echo "</div></td></tr>";
            }
        //}
        echo "<tr><td colspan=4 class='fop2pluginseparator'>&nbsp;</td></tr>";
    }

    echo "</tbody></table>";

}	
?>
  </div>
</div>
<hr style='color: #bbb; background-color: #bbb; height: 2px;'/>
<div id='uploadplugin'>
  <div class='category' id='category_upload'>
  <h3> <?php echo __("Upload Plugin"); ?></h3>
<p><?php echo __('You can upload a tar gzip file containing a FOP2 plugin from your local system. If a plugin with the same name already exists, it will be overwritten.'); ?></p>
<br/>
<form class='form-horizontal' name="plugin-upload" action="<?php echo SELF;?>" method="post" enctype="multipart/form-data">
<input type="hidden" name="action" value="upload" />
<input type="file" class='control-form' name="uploadplug" /> &nbsp;&nbsp; <button class='btn btn-primary' type="submit"><?php echo __('Upload');?></button>
</form>
  </div>
</div>
</div>
<br/>
<br/>
<script>
$(document).ready(function() {
    $('input[type=file]').bootstrapFileInput();
    $('.file-input-wrapper').find('span').html('<?php echo __('Browse');?>');
});

alertify.set({
    labels: {
        ok: '<?php echo __('Accept');?>',
        cancel: '<?php echo __('Cancel');?>'
    }
});

function setUninstall(rawname) {
     alertify.confirm('<?php echo __('Are you sure?'); ?>', function(e) {
         if (e) {
             $('#delete_'+rawname).submit();
         } else {
             return false;
         }
     });
}

function getPlugin(plugin) {
    $('#statusmodal').modal();
    var mydata = "action=getplugin&itemid="+plugin;
    $.post(window.location.href, mydata, function(data) {
        if(data.indexOf('ERROR')>=0) {
            $('#statusmodal').modal('hide');
            if(data.indexOf('ERROR1')>=0) {
                error = data.substr(7);
                alertify.error('<?php echo __("Error extracting plugin archive");?> ('+error+')');
            }
        } else {
            alertify.success('<?php echo __("Plugin installed successfully. You need to enable it globally or assign it to some users to make it available."); ?>');
        }
        $('#statusmodal').modal('hide');
        window.location.reload();
    });
}

function toggleconfig(rawname) {
    $('#config_'+rawname).toggle();
}

</script>

<div id='statusmodal' class="modal fade" tabindex="-1" role="dialog" aria-hidden="true">
    <div class="modal-dialog modal-sm">
        <div class="modal-content">
            <div class="modal-header">
                <h3><?php echo __('Please wait...');?></h3>
            </div>
            <div class="modal-body">
                <div class="progress progress-striped active">
                    <div class="progress-bar progress-bar-info" role="progressbar" aria-valuenow="1000" aria-valuemin="0" aria-valuemax="100" style="width: 100%">
               </div>
           </div>
       </div>
    </div>
</div>

</div>
<?php
include("footerbs.php");
